VoiceServerPrint = LibStub("AceAddon-3.0"):NewAddon("VoiceServerPrint", "AceConsole-3.0")

local options = {
    name = "VoiceServerPrint",
    handler = VoiceServerPrint,
    type = 'group',
    childGroups = 'tab',
    args = {
        add = {
            type = 'group',
            handler = VoiceServerPrint,
            name = 'Add Server',
            args = {
               serverName = {
                  type = 'input',
                  name = 'Voice Server Name',
                  desc = 'The Name of your Voice Server',
                  set = 'SetServerName',
                  get = 'GetServerName',
               },
               IP = {
                  type = 'input',
                  name = 'Voice Server IP',
                  desc = 'The IP Adress of your Voice Server',
                  set = 'SetIP',
                  get = 'GetIP',
               },
               Port = {
                  type = 'input',
                  name = 'Voice Server Port',
                  desc = 'The Port of your Voice Server',
                  set = 'SetPort',
                  get = 'GetPort',
               },
               Pw = {
                  type = 'input',
                  name = 'Voice Server Pw',
                  desc = 'The PW of your Voice Server',
                  set = 'SetPw',
                  get = 'GetPw',
               },
               addButton = {
                  type = 'execute',
                  name = 'Add',
                  desc = 'writes the Data to the Server List',
                  func = 'addServer'
               },
            },
         },    
        prints = {
            type = 'group',
            handler = VoiceServerPrint,
            name = 'Post Server',
            args = {
            
               show = {
                  type = 'execute',
                  name = 'Self',
                  desc = 'Prints your VoiceServer Informations to yourself',
                  func = 'showInfo'
               },
               bg = {
                  type = 'execute',
                  name = 'BG',
                  desc = 'Prints your VoiceServer Informations to the bg',
                  func = 'showBG'
               },
               group = {
                  type = 'execute',
                  name = 'Party',
                  desc = 'Prints your VoiceServer Informations to the party',
                  func = 'showGroup'
               },
               raid = {
                  type = 'execute',
                  name = 'Raid',
                  desc = 'Prints your VoiceServer Informations to the raid',
                  func = 'showRaid'
               },
               rw = {
                  type = 'execute',
                  name = 'RW',
                  desc = 'Prints your VoiceServer Informations to the raidwarning (needs promotion)',
                  func = 'showRaidWarning'
               },
            
            },
        },
        gui = {
            type = 'execute',
            name = 'GUI',
            desc = 'Brings up the Grafical User Interface',
            func = 'ToogleGUI'
        },
        short = {
            type = 'toggle',
            name = 'Short Message Style',
            desc = 'Check to print as Server: <ip:port>',
            get  = 'GetShort',
            set  = 'SetShort',
        },
        debug = {
            type = 'toggle',
            name = 'Debug Mode',
            desc = 'Check to enable debug messages',
            get  = 'GetDebug',
            set  = 'SetDebug',
        },
        servers = {
            type = 'select',
            name = 'Active Server',
            desc = 'Select your active voiceserver',
            values = 'GetServerTable',
            get = 'GetServerInfo',
            set = 'SetServerInfo',
            style = 'dropdown',
        },
        delservers = {
            type = 'select',
            name = 'Delete Server',
            desc = 'Delete a voice server from the table',
            values = 'GetServerTable',
            get = 'GetServerInfoZwei',
            set = 'DelServerInfo',
            style = 'dropdown',
        },
        
    },
}


function VoiceServerPrint:OnInitialize()
  -- Code that you want to run when the addon is first loaded goes here.
   self:Print('|cFFFF0000Voice|cFFFFFFFFServer|rPrint|r loaded')
   LibStub("AceConfig-3.0"):RegisterOptionsTable("VoiceServerPrint", options, {"voiceserverprint", "vsp"})
   self.db = LibStub("AceDB-3.0"):New("VoiceServerPrintDB",{
		profile = {
			minimap = {
				hide = false,
			},
		},
	})
	
	-- defaults
	self.db.global.welcome = 'VoiceServerPrint Release1'
   
   -- LDB
   local LDB = LibStub("LibDataBroker-1.1"):NewDataObject("VoiceServerPrint", {
	type = "data source",
	text = "VoiceServerPrint",
	icon = "Interface\\Icons\\Spell_Nature_TimeStop",
	OnClick = function() VoiceServerPrint:ToogleGUI() end,
   })
   
   -- Minimap Icon
   local icon = LibStub("LibDBIcon-1.0")
   icon:Register("VoiceServerPrint", LDB, self.db.profile.minimap)
   
   -- Blizzard Options Panel   
   self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VoiceServerPrint", "VoiceServerPrint")
   
   -- Default Server Table for Testing reasons
   if(not self.db.global.active) then self.db.global.active = 0 end
   if(not self.db.global.servers) then self.db.global.servers = {} end
   if(not self.db.global.serverinfo) then self.db.global.serverinfo = {} end
   self.db.global.dummy = 9999
   
   self.db.global.servers[9999] = " "
   
   --[[
   self.db.global.servers[0] = 'merged'
   self.db.global.servers[1] = 'lor'
   self.db.global.servers[2] = 'spaetschicht'
   
   
   -- insert some rnd servers here
   for i = 0, 2, 1 do
   
   self.db.global.serverinfo[i] = {
      name = self.db.global.servers[i],
      ip   = 'merged-gilde.de',
      port = '9987',
      pw   = i,
   }
   
   end
   ]]--
   
   
   

   
end

function VoiceServerPrint:OnEnable()
    -- Called when the addon is enabled
end

function VoiceServerPrint:OnDisable()
    -- Called when the addon is disabled
end


function VoiceServerPrint:showInfo()
    -- Called when /vsp show
     self:Print(self.db.global.welcome)
     self:Print(self.db.global.serverinfo[self.db.global.active].name)
     
      if self.db.global.Short 
    then 
      self:Print('Server: '..self.db.global.serverinfo[self.db.global.active].ip..':'..self.db.global.serverinfo[self.db.global.active].port)
    else 
      self:Print('Server: '..self.db.global.serverinfo[self.db.global.active].ip)
      self:Print('Port: '..self.db.global.serverinfo[self.db.global.active].port)
    end
    
    self:Print('Pw: '..self.db.global.serverinfo[self.db.global.active].pw)
end

function VoiceServerPrint:showBG()
    -- Called when /vsp show     
     self:PrintServer('BATTLEGROUND',0)
end

function VoiceServerPrint:showGroup()
    -- Called when /vsp show
     self:PrintServer('PARTY',0)
end

function VoiceServerPrint:showRaid()
    -- Called when /vsp show     
     self:PrintServer('RAID',0)
end

function VoiceServerPrint:showRaidWarning()
    -- Called when /vsp show     
     self:PrintServer('RAID_WARNING',0)
end
-- Get and Set Start


function VoiceServerPrint:GetServerName(info)
    -- Returns the Saved Port
    return self.db.global.Tempname
end

function VoiceServerPrint:SetServerName(info, input)
    -- Saves a Port
    self.db.global.Tempname = input
end
function VoiceServerPrint:GetIP(info)
    -- Returns the Saved IP
    return self.db.global.Tempip
end

function VoiceServerPrint:SetIP(info, input)
    -- Saves an IP
    self.db.global.Tempip = input
end

function VoiceServerPrint:GetPort(info)
    -- Returns the Saved Port
    return self.db.global.Tempport
end

function VoiceServerPrint:SetPort(info, input)
    -- Saves a Port
    self.db.global.Tempport = input
end

function VoiceServerPrint:GetPw(info)
    -- Returns the Saved Pw
    return self.db.global.Temppw
end

function VoiceServerPrint:SetPw(info, input)
    -- Saves the Pw
    self.db.global.Temppw = input
end

function VoiceServerPrint:ToogleGUI()
    -- shows or hides the gui
    --if self.frame:IsShown() then self.frame:Hide() else self.frame:Show() end
    self:PrintDebug("Build Gui called")
    self:BuildGUI()
end

function VoiceServerPrint:GetShort(info)
    -- Returns the Short
    self:PrintDebug("Short State Requestet")
    return self.db.global.Short
end

function VoiceServerPrint:SetShort(info, input)
    -- Sets the short state
    self:PrintDebug("Changed Short State")
    self.db.global.Short = input
end
function VoiceServerPrint:GetDebug(info)
    -- Returns the DebugVar
    return self.db.global.DebugVar
end

function VoiceServerPrint:SetDebug(info, input)
    -- Sets Debug State
    self:PrintDebug("Changed value of DebugVar")
    self.db.global.DebugVar = input
end


function VoiceServerPrint:PrintServer(to,DBIndex)
    -- to = target chat channel
    -- DBIndex (Multiple Server PRE)
    
    -- determine whether player is promoted
    local offi = false
    if(to == 'RAID_WARNING') then
       if(IsRaidOfficer() or IsRaidLeader()) then
         offi = true
       end
       -- if not send to RAID
       if(not offi) then
         self:Print('You are not promoted send to raid instead!')
         to = 'RAID'
       end       
    end
    
    -- Send Chat Message
    SendChatMessage(self.db.global.welcome,to)
    SendChatMessage(self.db.global.serverinfo[self.db.global.active].name,to)
    if self.db.global.Short 
    then 
    SendChatMessage('Server: '..self.db.global.serverinfo[self.db.global.active].ip..':'..self.db.global.serverinfo[self.db.global.active].port,to)
    else 
    SendChatMessage('Server: '..self.db.global.serverinfo[self.db.global.active].ip,to)
    SendChatMessage('Port: '..self.db.global.serverinfo[self.db.global.active].port,to)
    end
    
    SendChatMessage('Password: '..self.db.global.serverinfo[self.db.global.active].pw,to)
    
    
end
function VoiceServerPrint:PrintDebug(m)
    if(self:GetDebug()) then
         self:Print("Debug Message: "..m)
    end
end

function VoiceServerPrint:GetServerTable()
    -- called to get the server table for the dropdown
    -- return [index] = name
    self:PrintDebug("ServerTable Requestet")
    return self.db.global.servers
end

function VoiceServerPrint:GetServerInfo()
    -- return informations of 1 Server
    
    self:PrintDebug("Get Active Server: "..self.db.global.active)
    return self.db.global.active
end
  
function VoiceServerPrint:SetServerInfo(info, key)
    -- SetActive Server
    self:PrintDebug("Set Active Server: "..key)
    self.db.global.active = key
end

function VoiceServerPrint:DelServerInfo(info, key)
    -- SetActive Server
    self:PrintDebug("Delete Server: "..key)
    self.db.global.servers[key] = nil
    self.db.global.serverinfo[key] = nil
end

function VoiceServerPrint:GetServerInfoZwei()
    -- return dummy for delete
    
    self:PrintDebug("Get Delete Server: "..self.db.global.dummy)
    return self.db.global.dummy
end

function VoiceServerPrint:addServer()
    -- write temp var servers to the serverlist
    
    self:PrintDebug("Start Add Server")
    
    index = table.getn(self.db.global.servers)
    self:PrintDebug("Server Table Index: "..index)
    
    index = index+1
    
    self:PrintDebug("Server Table |cFFFF0000NEW|r Index: "..index)
    
    self.db.global.servers[index] = self.db.global.Tempname
    self.db.global.serverinfo[index] = {
      name = self.db.global.Tempname,
      ip   = self.db.global.Tempip,
      port = self.db.global.Tempport,
      pw   = self.db.global.Temppw,
   }
    

end





function VoiceServerPrint:BuildGUI()
    -- Builds the GUI


local   AceGUI = LibStub("AceGUI-3.0")
local frame = AceGUI:Create("Frame")
frame:SetTitle("VoiceServerPrint")
frame:SetStatusText("(c) by Isiss - Mal'Ganis | EU")
frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
frame:SetWidth(300)
frame:SetHeight(300)
frame:SetLayout("List")

local state = self.GetPartyState()


local dropDown = AceGUI:Create("DropdownGroup")
--dropDown:SetTitle("Server")
dropDown:SetGroupList(self.db.global.servers)
dropDown:SetGroup(self.db.global.active)
dropDown:SetDropdownWidth(150)
dropDown:SetCallback("OnGroupSelected", function(self,event,selection) VoiceServerPrint:SetServerInfo(info, selection) end)
frame:AddChild(dropDown)



local button = AceGUI:Create("Button")
button:SetText("Self")
button:SetWidth(100)
button:SetCallback("OnClick", function() VoiceServerPrint:showInfo() end)
frame:AddChild(button)


local button = AceGUI:Create("Button")
button:SetText("Party")
button:SetWidth(100)
button:SetCallback("OnClick", function() VoiceServerPrint:showGroup() end)
if state == "solo" or state == "raid" or state == "heroic_raid" or state == "bg" then button:SetDisabled(true) end
frame:AddChild(button)

local button = AceGUI:Create("Button")
button:SetText("Raid")
button:SetWidth(100)
button:SetCallback("OnClick", function() VoiceServerPrint:showRaid() end)
if state == "solo" or state =="party" then button:SetDisabled(true) end
frame:AddChild(button)

local button = AceGUI:Create("Button")
button:SetText("RW")
button:SetWidth(100)
button:SetCallback("OnClick", function() VoiceServerPrint:showRaidWarning() end)
if state == "solo" or state =="party" then button:SetDisabled(true) end
frame:AddChild(button)

local button = AceGUI:Create("Button")
button:SetText("BG")
button:SetWidth(100)
button:SetCallback("OnClick", function() VoiceServerPrint:showBG() end)
if state == "bg" then else button:SetDisabled(true) end
frame:AddChild(button)


end

function VoiceServerPrint:GetPartyState()
		local _, instance_type = IsInInstance()

		if instance_type == "arena" then
			return "arena"
		end

		if instance_type == "pvp" then
			return "bg"
		end

		if GetNumRaidMembers() > 0 then
			if instance_type == "none" and GetZonePVPInfo() == "combat" then
				return "bg"
			end
			local raid_difficulty = GetRaidDifficulty()
			if raid_difficulty == 2 or raid_difficulty == 4 then
				return "heroic_raid"
			else
				return "raid"
			end
		end

		if GetNumPartyMembers() > 0 then
			return "party"
		end

		return "solo"
	end